package com.zhongzheng.modules.system.service.impl;

import cn.hutool.core.lang.Validator;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.zhongzheng.common.core.domain.entity.SysDictData;
import com.zhongzheng.common.core.domain.entity.SysDictType;
import com.zhongzheng.common.core.domain.entity.TopSysUser;
import com.zhongzheng.common.exception.CustomException;
import com.zhongzheng.common.utils.DictUtils;
import com.zhongzheng.modules.course.domain.MajorCategory;
import com.zhongzheng.modules.system.mapper.SysDictDataMapper;
import com.zhongzheng.modules.system.service.ISysDictDataService;
import org.springframework.stereotype.Service;

import java.util.Arrays;
import java.util.List;

/**
 * 字典 业务层处理
 *
 * @author zhongzheng
 */
@Service
public class SysDictDataServiceImpl extends ServiceImpl<SysDictDataMapper, SysDictData> implements ISysDictDataService {

    /**
     * 根据条件分页查询字典数据
     *
     * @param dictData 字典数据信息
     * @return 字典数据集合信息
     */
    @Override
    public List<SysDictData> selectDictDataList(SysDictData dictData) {
        return list(new LambdaQueryWrapper<SysDictData>().eq(StrUtil.isNotBlank(dictData.getDictType()), SysDictData::getDictType, dictData.getDictType())
                .like(StrUtil.isNotBlank(dictData.getDictLabel()), SysDictData::getDictLabel, dictData.getDictLabel())
                .eq(StrUtil.isNotBlank(dictData.getStatus()), SysDictData::getStatus, dictData.getStatus())
                .in(dictData.getStatusArray()!=null, SysDictData::getStatus, dictData.getStatusArray())
                .eq(dictData.getDictTypeId()!=null, SysDictData::getDictTypeId, dictData.getDictTypeId())
                .orderByAsc(SysDictData::getDictSort));
    }

    /**
     * 根据字典类型和字典键值查询字典数据信息
     *
     * @param dictType  字典类型
     * @param dictValue 字典键值
     * @return 字典标签
     */
    @Override
    public String selectDictLabel(String dictType, String dictValue) {
        return getOne(new LambdaQueryWrapper<SysDictData>()
                .select(SysDictData::getDictLabel)
                .eq(SysDictData::getDictType, dictType)
                .eq(SysDictData::getDictValue, dictValue))
                .getDictLabel();
    }

    /**
     * 根据字典数据ID查询信息
     *
     * @param dictCode 字典数据ID
     * @return 字典数据
     */
    @Override
    public SysDictData selectDictDataById(Long dictCode) {
        return getById(dictCode);
    }

    /**
     * 批量删除字典数据信息
     *
     * @param dictCodes 需要删除的字典数据ID
     * @return 结果
     */
    @Override
    public int deleteDictDataByIds(Long[] dictCodes) {
        int row = baseMapper.deleteBatchIds(Arrays.asList(dictCodes));
        if (row > 0) {
            DictUtils.clearDictCache();
        }
        return row;
    }

    /**
     * 新增保存字典数据信息
     *
     * @param dictData 字典数据信息
     * @return 结果
     */
    @Override
    public int insertDictData(SysDictData dictData) {
        validEntityBeforeSave(dictData);
        int row = baseMapper.insert(dictData);
        if (row > 0) {
            DictUtils.clearDictCache();
        }
        return row;
    }

    /**
     * 修改保存字典数据信息
     *
     * @param dictData 字典数据信息
     * @return 结果
     */
    @Override
    public int updateDictData(SysDictData dictData) {
        validEntityBeforeSave(dictData);
        int row = baseMapper.updateById(dictData);
        if (row > 0) {
            DictUtils.clearDictCache();
        }
        return row;
    }

    @Override
    public Long selectDictLabelType(String company_type, String toString) {
        return  getOne(new LambdaQueryWrapper<SysDictData>()
                .select(SysDictData::getDictCode)
                .eq(SysDictData::getDictType, company_type)
                .eq(SysDictData::getDictLabel, toString))
                .getDictCode();
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(SysDictData entity){
        //TODO 做一些数据校验,如唯一约束
        if(checkDictValueUnique(entity)){
            throw new CustomException("该键值已存在");
        }
    }

    private boolean checkDictValueUnique(SysDictData entity) {
        SysDictData info = getOne(new LambdaQueryWrapper<SysDictData>()
                .eq(SysDictData::getDictValue,entity.getDictValue())
                .eq(SysDictData::getDictType,entity.getDictType())
                .last("limit 1"));
        if (Validator.isNotNull(info)) {
            return true;
        }
        return false;
    }
}
